import bpy
        
class RAIN_DELETE_Rain(bpy.types.Operator):
    """Delete selected rain"""
    bl_idname = "rain.delete"
    bl_label = "Delete Rain"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        target = bpy.context.active_object
        rain_colls = target.users_collection

        for coll in rain_colls:
            if coll.name.startswith('BRG_Rain'):
                for parent_collection in bpy.data.collections:
                    if coll.name in parent_collection.children.keys():
                        if parent_collection.name.startswith('Baga Rain Generator'):
                            main_coll = parent_collection # MAIN COLLECTION
                            rain_coll = coll # RAIN COLLECTION
                            for colls in coll.children.keys():
                                if colls.startswith('BRG_Targets'):
                                    target_coll = bpy.data.collections[colls] # TARGET COLLECTION

        for ob in target_coll.all_objects:
            target_coll.objects.unlink(ob) 

        bpy.data.collections.remove(target_coll)
        bpy.data.collections.remove(rain_coll)
        bpy.data.objects.remove(target, do_unlink=True)
        
        if len(main_coll.children.keys()) < 1:
            bpy.data.collections.remove(main_coll)
            
        return {'FINISHED'}